<template>
    <div>
        <base-card>
        <div class="controls">
            <base-button mode="delineado" link to="/registro_mascota">Agregar Mascota</base-button>
        </div>
        <div v-if="enCargaMascotas">
            <base-spinner></base-spinner>
        </div>
        <ul v-else-if="existenMascotas">
            <item-mascota v-for="mascota in listaMascotas" 
            :key="mascota.id" 
            :id="mascota.id"
            :nombre="mascota.nombre"
            :edad="mascota.edad"
            :especie="mascota.especie"
            :descripcion="mascota.descripcion"></item-mascota>
        </ul>
        <h3 v-else>No se encuentran mascotas disponibles por el momento.</h3>
        </base-card>
    </div>
</template>
<script>
import ItemMascota from '../../components/mascotas/ItemMascota.vue';
export default {
    components:{
        ItemMascota
    },
    data() {
        return{
            enCargaMascotas: false, 
            listaMascotas:[]
        };   
    },
    created(){
        this.cargarMascotas();
        this.obtenerListaMascotas();
    },
    computed:{
        existenMascotas(){
            return !this.enCargaMascotas && this.$store.getters['mascotas/existenMascotas'];
        }
    },
    methods:{
        async cargarMascotas(){
            this.enCargaMascotas=true;
            await this.$store.dispatch('mascotas/cargarMascotas');
            this.enCargaMascotas=false;
        },
        obtenerListaMascotas(){
            this.listaMascotas=this.$store.getters['mascotas/mascotas'];
            console.log(this.listaMascotas);
        },
    }
}
</script>
<style scoped>
.contenido{
    margin-top: 5rem;
}
.controls {
  display: flex;
  justify-content: space-between;
}
ul {
  list-style: none;
  margin: 0;
  padding: 0;
}
button:active,
button:hover,
button.base-button-active {
  border: 1px solid white;
}
</style>